%             midpoint2.m
% Implicit Euler method
% f: vectorfield
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t x] = midpoint2(f,t0,tf,x0,N)
 h = (tf-t0)/N; tol=1.e-8;
 t=t0:h:tf; x=x0';y=x0; K1= f(t(1),y);
 for i=1:N;
   K1i=K1;
   while 1
      K1 = f(t(i)+h/2,y+h*K1i/2);
      if norm(K1-K1i) < tol, break, end
      K1i=K1;
   end
   y = y + h*K1;
   x = [x ; y' ];
 end

